'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EditableCell = function (_React$Component) {
  _inherits(EditableCell, _React$Component);

  function EditableCell(props) {
    _classCallCheck(this, EditableCell);

    var _this = _possibleConstructorReturn(this, (EditableCell.__proto__ || Object.getPrototypeOf(EditableCell)).call(this, props));

    _this.state = {
      edit: props.edit
    };
    return _this;
  }

  _createClass(EditableCell, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(props) {
      this.setState({
        edit: props.edit
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          disabled = _props.disabled,
          id = _props.id,
          onChange = _props.onChange,
          placeholder = _props.placeholder,
          required = _props.required,
          type = _props.type,
          value = _props.value;

      var input = this.state.edit ? _react2.default.createElement('input', {
        className: 'form-control',
        disabled: disabled,
        id: id,
        onChange: onChange,
        placeholder: placeholder,
        required: required,
        type: type,
        value: value }) : _react2.default.createElement(
        'span',
        { id: id + 'Value' },
        value
      );
      return _react2.default.createElement(
        'td',
        { id: id + 'Cell' },
        input
      );
    }
  }]);

  return EditableCell;
}(_react2.default.Component);

exports.default = EditableCell;


EditableCell.defaultProps = {
  disabled: false,
  required: false
};

EditableCell.propTypes = {
  disabled: _propTypes2.default.bool,
  edit: _propTypes2.default.string,
  id: _propTypes2.default.string.isRequired,
  onChange: _propTypes2.default.func.isRequired,
  placeholder: _propTypes2.default.string,
  required: _propTypes2.default.bool,
  type: _propTypes2.default.oneOf(['text', 'password', 'radio', 'checkbox', 'color', 'date', 'datetime-local', 'email', 'month', 'number', 'range', 'search', 'tel', 'time', 'url', 'week']),
  value: _propTypes2.default.string.isRequired
};