'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Editor = require('./Editor');

var _Editor2 = _interopRequireDefault(_Editor);

var _Viewer = require('./Viewer');

var _Viewer2 = _interopRequireDefault(_Viewer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Item = function (_React$Component) {
  _inherits(Item, _React$Component);

  function Item(props) {
    _classCallCheck(this, Item);

    var _this = _possibleConstructorReturn(this, (Item.__proto__ || Object.getPrototypeOf(Item)).call(this, props));

    _this.state = {
      editing: false
    };
    _this.editing = _this.editing.bind(_this);
    _this.remove = _this.remove.bind(_this);
    _this.save = _this.save.bind(_this);
    return _this;
  }

  _createClass(Item, [{
    key: 'editing',
    value: function editing() {
      this.setState({
        editing: true
      });
    }
  }, {
    key: 'editor',
    value: function editor() {
      var _props = this.props,
          id = _props.id,
          formElements = _props.formElements,
          onCancel = _props.onCancel,
          onChange = _props.onChange,
          item = _props.item;

      return _react2.default.createElement(_Editor2.default, { id: 'list_editor_ ' + id,
        onCancel: onCancel,
        onChange: onChange,
        onSave: this.save,
        formElements: formElements,
        item: item });
    }
  }, {
    key: 'remove',
    value: function remove() {
      this.props.remove(this.props.item);
    }
  }, {
    key: 'render',
    value: function render() {
      var editing = this.state.editing;

      return editing ? this.editor() : this.viewer();
    }
  }, {
    key: 'save',
    value: function save(item) {
      this.setState({
        editing: false
      });
      this.props.onSave(item);
    }
  }, {
    key: 'viewer',
    value: function viewer() {
      var _props2 = this.props,
          body = _props2.body,
          header = _props2.header,
          id = _props2.id,
          item = _props2.item;

      return _react2.default.createElement(_Viewer2.default, { body: body(item), header: header(item), id: id, onEditButtonClick: this.editing,
        onRemoveButtonClick: this.remove });
    }
  }]);

  return Item;
}(_react2.default.Component);

Item.propTypes = {
  body: _propTypes2.default.func.isRequired,
  formElements: _propTypes2.default.func.isRequired,
  header: _propTypes2.default.func.isRequired,
  id: _propTypes2.default.string.isRequired,
  item: _propTypes2.default.object.isRequired,
  onCancel: _propTypes2.default.func.isRequired,
  onChange: _propTypes2.default.func.isRequired,
  onSave: _propTypes2.default.func.isRequired,
  remove: _propTypes2.default.func.isRequired
};

exports.default = Item;