'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Alert = require('./Alert');

var _Alert2 = _interopRequireDefault(_Alert);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormGroup = function (_React$Component) {
  _inherits(FormGroup, _React$Component);

  function FormGroup() {
    _classCallCheck(this, FormGroup);

    return _possibleConstructorReturn(this, (FormGroup.__proto__ || Object.getPrototypeOf(FormGroup)).apply(this, arguments));
  }

  _createClass(FormGroup, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          error = _props.error,
          id = _props.id,
          label = _props.label,
          required = _props.required;

      var validationStatus = '';
      var requiredText = '';
      var alert = '';
      if (error) {
        validationStatus = 'has-error';
        alert = _react2.default.createElement(_Alert2.default, { id: id, type: 'danger', message: error });
      }
      var childrenWithProps = this.props.children;
      if (required) {
        requiredText = _react2.default.createElement(
          'small',
          { className: 'text-danger' },
          'Required'
        );
        childrenWithProps = _react2.default.Children.map(this.props.children, function (child) {
          return _react2.default.cloneElement(child, { required: true });
        });
      }

      return _react2.default.createElement(
        'div',
        { id: id + 'FormGroup', className: 'form-group ' + validationStatus },
        _react2.default.createElement(
          'label',
          { id: id + 'Label', className: 'control-label', htmlFor: id },
          label,
          '\xA0',
          requiredText
        ),
        childrenWithProps,
        alert
      );
    }
  }]);

  return FormGroup;
}(_react2.default.Component);

exports.default = FormGroup;


FormGroup.defaultProps = {
  required: false
};

FormGroup.propTypes = {
  children: _propTypes2.default.node.isRequired,
  error: _propTypes2.default.string,
  id: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string,
  required: _propTypes2.default.bool
};