'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ProgressBar = function (_React$Component) {
  _inherits(ProgressBar, _React$Component);

  function ProgressBar() {
    _classCallCheck(this, ProgressBar);

    return _possibleConstructorReturn(this, (ProgressBar.__proto__ || Object.getPrototypeOf(ProgressBar)).apply(this, arguments));
  }

  _createClass(ProgressBar, [{
    key: 'render',
    value: function render() {
      var currentStyle = {
        width: this.props.now + '%',
        minWidth: this.props.minWidth + 'em'
      };
      var className = 'progress-bar progress-bar-' + this.props.context + (this.props.striped ? ' progress-bar-striped' : '') + (this.props.animated ? ' active' : '');
      return _react2.default.createElement(
        'div',
        { id: 'ProgressBarComponent_' + this.props.id, className: className,
          role: 'progressbar',
          'area-valuemax': this.props.max,
          'area-valuemin': this.props.min,
          'aria-valuenow': this.props.now,
          style: currentStyle },
        this.props.label
      );
    }
  }]);

  return ProgressBar;
}(_react2.default.Component);

exports.default = ProgressBar;


ProgressBar.propTypes = {
  animated: _propTypes2.default.bool,
  context: _propTypes2.default.oneOf(['primary', 'success', 'info', 'warn', 'danger', 'default']),
  id: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string,
  min: _propTypes2.default.number.isRequired,
  minWidth: _propTypes2.default.number,
  max: _propTypes2.default.number.isRequired,
  now: _propTypes2.default.number.isRequired,
  striped: _propTypes2.default.bool
};

ProgressBar.defaultProps = {
  animated: false,
  context: 'default',
  minWidth: 2,
  striped: false
};